LeetCode 1438. Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit

Posted qwfand

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了LeetCode 1438. Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit相关的知识,希望对你有一定的参考价值。

1438. Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit

Given an array of integers nums and an integer limit, return the size of the longest continuous subarray such that the absolute difference between any two elements is less than or equal to limit.

In case there is no subarray satisfying the given condition return 0.

Example 1:

Input: nums = [8,2,4,7], limit = 4
Output: 2
Explanation: All subarrays are:
[8] with maximum absolute diff |8-8| = 0 <= 4.
[8,2] with maximum absolute diff |8-2| = 6 > 4.
[8,2,4] with maximum absolute diff |8-2| = 6 > 4.
[8,2,4,7] with maximum absolute diff |8-2| = 6 > 4.
[2] with maximum absolute diff |2-2| = 0 <= 4.
[2,4] with maximum absolute diff |2-4| = 2 <= 4.
[2,4,7] with maximum absolute diff |2-7| = 5 > 4.
[4] with maximum absolute diff |4-4| = 0 <= 4.
[4,7] with maximum absolute diff |4-7| = 3 <= 4.
[7] with maximum absolute diff |7-7| = 0 <= 4.
Therefore, the size of the longest subarray is 2.
Example 2:

Input: nums = [10,1,2,4,7,2], limit = 5
Output: 4
Explanation: The subarray [2,4,7,2] is the longest since the maximum absolute diff is |2-7| = 5 <= 5.
Example 3:

Input: nums = [4,2,2,2,4,4,2,2], limit = 0
Output: 3

Constraints:

1 <= nums.length <= 10^5
1 <= nums[i] <= 10^9
0 <= limit <= 10^9

solution

approach1:Sliding window

这种解法使用了一个list来保存满足条件的元素,使用了较多的空间
也可以只使用两个pointer来完成,每次right pointer 移动的时候更新最大值和最小值,很容易做到,但是在left pointer 移动的时候更新最大值和最小值,是不是需要遍历 left pointer 到right pointer 之间的元素,目前没有想到更好的方法来处理这一问题。

class Solution:
    def longestSubarray(self, nums: List[int], limit: int) -> int:
        lenmax=1
        maxi=nums[0]
        mini=nums[0]
        tmp=nums[0:1]
        for i in range(1,len(nums)):
            tmp.append(nums[i])
            if nums[i]>maxi:
                maxi=nums[i]
            if nums[i]<mini:
                mini=nums[i]
                
            if maxi-mini<=limit:
                if len(tmp)>lenmax:
                    lenmax=len(tmp)
            else:
                tmp.pop(0)
                while  max(tmp)-min(tmp)>limit:
                    tmp.pop(0)
                maxi=max(tmp)
                mini=min(tmp)

        return lenmax

approach2 :brute force

class Solution:
    def longestSubarray(self, nums: List[int], limit: int) 
        lenmax=1
        for i in range(len(nums)):
            for j in range(i+1,len(nums)+1):
                tmp=nums[i:j]
                if max(tmp)-min(tmp)<=limit:
                    if len(tmp)>lenmax:
                        lenmax=len(tmp)
        return lenmax

参考链接

leetcode

以上是关于LeetCode 1438. Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit的主要内容,如果未能解决你的问题,请参考以下文章

[leetcode] No.1438 绝对差不超过限制的最长连续子数组

[leetcode] No.1438 绝对差不超过限制的最长连续子数组

leetcode 1438. 绝对差不超过限制的最长连续子数组----双指针篇3,滑动窗口篇2

⭐算法入门⭐《队列 - 单调队列》中等02 —— LeetCode 1438. 绝对差不超过限制的最长连续子数组

LeetCode Longest Palindrome

leetcode:longest words